//*****************************************************************************
// copyright (c) 1991-2005 TLK Games all rights reserved
//-----------------------------------------------------------------------------
// file         : "main.cc"
// created      : 2002-08-21
// updates      : 2005-01-23
// id		: $Id: main.cc,v 1.3 2005/01/23 19:52:24 gurumeditation Exp $
//-----------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
// 
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
#define _GNU_SOURCE /* this must be done before the first include of unistd.h */
#include <unistd.h>
#include "../include/ressources.h"
#include "../include/mentatCode.h"
#include "../include/ecran_hard.h"
#include "../include/audiomixer.h"
#include "../include/configfile.h"
//..............................................................................
configfile oConfigure;

//------------------------------------------------------------------------------
// main function
//------------------------------------------------------------------------------
int main(Sint32 nbArg, char **ptArg)
{ 
	gid_t realgid;
	Sint32 error = 0;
	
	ressources::score_fhand = open(ressources::fnamescore, O_RDWR);

	/* Figure out who we really are. */
	realgid = getgid();

	/* This is where we drop our setuid/setgid privileges. */
	if (setresgid(-1, realgid, realgid) != 0) {
	    perror("Could not drop setgid privileges.  Aborting.");
	    exit(1);
	}
	
	oConfigure.loadconfig();
	if(!oConfigure.scanZeArgs(nbArg, ptArg))
		goto main_exit;
	if(mentatCode::is_verbose) 
	{	printf("===========================================================\n");
		printf("                       TECNOBALLZ START\n");
		printf("===========================================================\n");
	}
	error = mentatCode::first_init(&oConfigure);
	if(error) goto main_exit;
	error = mentatCode::game_begin();
	if(error) goto main_exit;
	if(mentatCode::is_verbose) 
		printf("===========================================================\n");
	error = mentatCode::desinstall(&oConfigure);
	if(error) goto main_exit;
	if(mentatCode::is_verbose) 
		printf("END =======================================================\n");
	oConfigure.saveconfig();

main_exit:
	if (ressources::score_fhand != -1)
		close(ressources::score_fhand);
	return error;
}
